Index: /gsdl/trunk/src/recpt/action.cpp
===================================================================
--- /gsdl/trunk/src/recpt/action.cpp	(revision 15588)
+++ /gsdl/trunk/src/recpt/action.cpp	(revision 15589)
@@ -44,7 +44,7 @@
   if (key == "gsdlhome") {
     gsdlhome = cfgline[0];
-    if (gdbmhome.empty()) gdbmhome = cfgline[0];
+    if (dbhome.empty()) dbhome = cfgline[0];
   }
-  if (key == "gdbmhome") {gdbmhome = cfgline[0];}
+  if (key == "gdbmhome") {dbhome = cfgline[0];}
 }
 
Index: /gsdl/trunk/src/recpt/action.h
===================================================================
--- /gsdl/trunk/src/recpt/action.h	(revision 15588)
+++ /gsdl/trunk/src/recpt/action.h	(revision 15589)
@@ -48,5 +48,5 @@
   cgiargsinfoclass argsinfo;
   text_t gsdlhome;
-  text_t gdbmhome;
+  text_t dbhome;
 
 public:
Index: /gsdl/trunk/src/recpt/authenaction.cpp
===================================================================
--- /gsdl/trunk/src/recpt/authenaction.cpp	(revision 15588)
+++ /gsdl/trunk/src/recpt/authenaction.cpp	(revision 15589)
@@ -131,6 +131,6 @@
 
 bool authenaction::init (ostream &logout) {
-  if (gdbmhome.empty()) {
-    logout << "ERROR (authenaction::init) gdbmhome is not set\n";
+  if (dbhome.empty()) {
+    logout << "ERROR (authenaction::init) dbhome is not set\n";
     return false;
   }
Index: /gsdl/trunk/src/recpt/cgiwrapper.cpp
===================================================================
--- /gsdl/trunk/src/recpt/cgiwrapper.cpp	(revision 15588)
+++ /gsdl/trunk/src/recpt/cgiwrapper.cpp	(revision 15589)
@@ -312,6 +312,6 @@
   
   cout << text_t2ascii << "gsdlhome=" << configinfo.gsdlhome << "\n";
-  if (!configinfo.gdbmhome.empty())
-    cout << text_t2ascii << "gdbmhome=" << configinfo.gdbmhome << "\n";
+  if (!configinfo.dbhome.empty())
+    cout << text_t2ascii << "dbhome=" << configinfo.dbhome << "\n";
   cout << text_t2ascii << "httpprefix=" << configinfo.httpprefix << "\n";
   cout << text_t2ascii << "httpimg=" << configinfo.httpimg << "\n";
Index: /gsdl/trunk/src/recpt/queryaction.cpp
===================================================================
--- /gsdl/trunk/src/recpt/queryaction.cpp	(revision 15588)
+++ /gsdl/trunk/src/recpt/queryaction.cpp	(revision 15589)
@@ -950,5 +950,5 @@
     text_t userid = args["z"];
     text_tarray entries;
-    if (get_history_info (userid, entries, gdbmhome, logout)) {
+    if (get_history_info (userid, entries, dbhome, logout)) {
       int count = 1;
       text_tarray::iterator here = entries.begin();
@@ -1812,5 +1812,5 @@
   int hd = args.getintarg("hd");
   if (hd > 0) display=true;
-  if (set_history_info(userid, query, gdbmhome, display)) return true;
+  if (set_history_info(userid, query, dbhome, display)) return true;
   else return false;
 
Index: /gsdl/trunk/src/recpt/receptionist.cpp
===================================================================
--- /gsdl/trunk/src/recpt/receptionist.cpp	(revision 15588)
+++ /gsdl/trunk/src/recpt/receptionist.cpp	(revision 15589)
@@ -52,5 +52,5 @@
 void recptconf::clear () {
   gsdlhome.clear();
-  gdbmhome.clear();
+  dbhome.clear();
   collectinfo.erase(collectinfo.begin(), collectinfo.end());
   collection.clear();
@@ -93,5 +93,5 @@
 void collectioninfo_t::clear () {
   gsdl_gsdlhome.clear();
-  gsdl_gdbmhome.clear();
+  gsdl_dbhome.clear();
 
   info_loaded = false;
@@ -220,7 +220,7 @@
     if (key == "gsdlhome") {
       configinfo.gsdlhome = cfgline[0];
-      if (configinfo.gdbmhome.empty()) configinfo.gdbmhome = cfgline[0];
-    }
-    else if (key == "gdbmhome") configinfo.gdbmhome = cfgline[0];
+      if (configinfo.dbhome.empty()) configinfo.dbhome = cfgline[0];
+    }
+    else if (key == "gdbmhome") configinfo.dbhome = cfgline[0];
     else if (key == "collection") {
       configinfo.collection = cfgline[0];
@@ -272,5 +272,5 @@
 	collectioninfo_t cinfo;
 	cinfo.gsdl_gsdlhome = cfgline[1];
-	cinfo.gsdl_gdbmhome = cfgline[2];
+	cinfo.gsdl_dbhome = cfgline[2];
 	configinfo.collectinfo[cfgline[0]] = cinfo;
       }
@@ -705,5 +705,5 @@
   }
 
-  text_t logfile = filename_cat (configinfo.gdbmhome, "etc", "usage.txt");
+  text_t logfile = filename_cat (configinfo.dbhome, "etc", "usage.txt");
 
   text_t logstr = script_name;
Index: /gsdl/trunk/src/recpt/receptionist.h
===================================================================
--- /gsdl/trunk/src/recpt/receptionist.h	(revision 15588)
+++ /gsdl/trunk/src/recpt/receptionist.h	(revision 15589)
@@ -55,5 +55,5 @@
 
   text_t gsdl_gsdlhome;
-  text_t gsdl_gdbmhome;
+  text_t gsdl_dbhome;
 
   bool info_loaded;
@@ -77,5 +77,5 @@
 struct recptconf {
    text_t gsdlhome;
-   text_t gdbmhome;   // will equal gsdlhome if not set
+   text_t dbhome;   // will equal gsdlhome if not set
    text_t collection; // will equal "" in 'general' mode
    text_t collectdir; // will equal gsdlhome in 'general' mode
Index: /gsdl/trunk/src/recpt/statusaction.cpp
===================================================================
--- /gsdl/trunk/src/recpt/statusaction.cpp	(revision 15588)
+++ /gsdl/trunk/src/recpt/statusaction.cpp	(revision 15589)
@@ -882,5 +882,5 @@
 				   ostream &textout, ostream &/*logout*/) {
 
-  text_t maincfgfile = filename_cat (gdbmhome, "etc", "main.cfg");
+  text_t maincfgfile = filename_cat (dbhome, "etc", "main.cfg");
 
   textout << outconvert << disp << "_status:infoheader_(main.cfg)\n"
Index: /gsdl/trunk/src/recpt/usersaction.cpp
===================================================================
--- /gsdl/trunk/src/recpt/usersaction.cpp	(revision 15588)
+++ /gsdl/trunk/src/recpt/usersaction.cpp	(revision 15589)
@@ -152,6 +152,6 @@
 bool usersaction::init (ostream &logout) {
 
-  if (gdbmhome.empty()) {
-    logout << "ERROR (usersaction::init) gdbmhome is not set\n";
+  if (dbhome.empty()) {
+    logout << "ERROR (usersaction::init) dbhome is not set\n";
     return false;
   }