Index: /gsdl/trunk/src/colservr/lucenequeryfilter.cpp
===================================================================
--- /gsdl/trunk/src/colservr/lucenequeryfilter.cpp	(revision 15593)
+++ /gsdl/trunk/src/colservr/lucenequeryfilter.cpp	(revision 15594)
@@ -108,5 +108,5 @@
     }
   } else if (key == "textlevel") {
-      ((lucenesearchclass *)textsearchptr)->set_gdbm_level( cfgline[0]);
+      ((lucenesearchclass *)textsearchptr)->set_text_level(cfgline[0]);
   }
   
Index: /gsdl/trunk/src/colservr/lucenesearch.cpp
===================================================================
--- /gsdl/trunk/src/colservr/lucenesearch.cpp	(revision 15593)
+++ /gsdl/trunk/src/colservr/lucenesearch.cpp	(revision 15594)
@@ -67,5 +67,5 @@
   : searchclass() {
 
-  gdbm_level = "Doc";
+  textlevel = "Doc";
 }
 
@@ -79,7 +79,7 @@
 }
 
-void lucenesearchclass::set_gdbm_level(const text_t &level) {
-  gdbm_level = level;
-  
+void lucenesearchclass::set_text_level(const text_t &textlevel_arg)
+{
+  textlevel = textlevel_arg;
 }
 
@@ -228,5 +228,5 @@
 					text_t &output) {
 
-  // we now get the document directly by lucenegdbmsource, so don't use this 
+  // we now get the document directly by lucenesource, so don't use this 
   // method
   return false;
Index: /gsdl/trunk/src/colservr/lucenesearch.h
===================================================================
--- /gsdl/trunk/src/colservr/lucenesearch.h	(revision 15593)
+++ /gsdl/trunk/src/colservr/lucenesearch.h	(revision 15594)
@@ -74,6 +74,7 @@
 		   char *&UDoc, int &ULen);
   */
-  void set_gdbm_level(const text_t &level);
-  text_t gdbm_level; // the default level used for retrieval, and in the gdbm file 
+
+  void set_text_level(const text_t &textlevel_arg);
+  text_t textlevel;
 
   // used to clear any cached databases for persistent versions of 
Index: /gsdl/trunk/src/colservr/lucenesource.cpp
===================================================================
--- /gsdl/trunk/src/colservr/lucenesource.cpp	(revision 15593)
+++ /gsdl/trunk/src/colservr/lucenesource.cpp	(revision 15594)
@@ -90,5 +90,5 @@
   doc.clear();
   db_ptr->closedatabase();  // Important that local library doesn't leave any files open
-  expat_document(full_path_to_doc, ((lucenesearchclass*)textsearchptr)->gdbm_level, text_t(docnum), doc);
+  expat_document(full_path_to_doc, ((lucenesearchclass*)textsearchptr)->textlevel, text_t(docnum), doc);
   return true;
 }
Index: /gsdl/trunk/src/colservr/mgppqueryfilter.cpp
===================================================================
--- /gsdl/trunk/src/colservr/mgppqueryfilter.cpp	(revision 15593)
+++ /gsdl/trunk/src/colservr/mgppqueryfilter.cpp	(revision 15594)
@@ -97,5 +97,5 @@
     }
   } else if (key == "textlevel") {
-      ((mgppsearchclass *)textsearchptr)->set_gdbm_level( cfgline[0]);
+      ((mgppsearchclass *)textsearchptr)->set_text_level(cfgline[0]);
   } else if (key == "indexstem") {
     ((mgppsearchclass *)textsearchptr)->set_indexstem (cfgline[0]);
Index: /gsdl/trunk/src/colservr/mgppsearch.cpp
===================================================================
--- /gsdl/trunk/src/colservr/mgppsearch.cpp	(revision 15593)
+++ /gsdl/trunk/src/colservr/mgppsearch.cpp	(revision 15594)
@@ -61,5 +61,5 @@
   : searchclass() {
 
-  gdbm_level = "Doc";
+  textlevel = "Doc";
   indexData = NULL;
 }
@@ -81,11 +81,12 @@
 }
 
-void mgppsearchclass::set_gdbm_level(const text_t &level) {
-  gdbm_level = level;
-  
-}
-void mgppsearchclass::set_indexstem(const text_t &stem) {
+void mgppsearchclass::set_text_level(const text_t &textlevel_arg)
+{
+  textlevel = textlevel_arg;
+}
+
+void mgppsearchclass::set_indexstem(const text_t &stem)
+{
   indexstem = stem;
-  
 }
 
@@ -160,5 +161,5 @@
   
   //set the level for results
-  SetCStr(level, gdbm_level.getcstr());
+  SetCStr(level, textlevel.getcstr());
 
   
@@ -308,5 +309,5 @@
   UCArray doctext;
   UCArray level;
-  SetCStr(level, gdbm_level.getcstr());
+  SetCStr(level, textlevel.getcstr());
   if (!GetDocText(textdata, level, (unsigned long)docnum, doctext)) {
     cout<<"couldn't retrieve document text\n";
Index: /gsdl/trunk/src/colservr/mgppsearch.h
===================================================================
--- /gsdl/trunk/src/colservr/mgppsearch.h	(revision 15593)
+++ /gsdl/trunk/src/colservr/mgppsearch.h	(revision 15594)
@@ -76,5 +76,5 @@
   */
   
-  void set_gdbm_level(const text_t &level);
+  void set_text_level(const text_t &textlevel_arg);
   
   void set_indexstem(const text_t &indexstem);
@@ -83,7 +83,8 @@
   // Greenstone like the Windows local library
   void unload_database ();
+
  protected:
   
-  text_t gdbm_level; // the default level used for retrieval, and in the gdbm file 
+  text_t textlevel;
   text_t indexstem; // the stem of the index file names
   IndexData *indexData; // the index data structure needed for MGQuery - keep