Index: /gsdl/trunk/lib/sqlitedbclass.cpp
===================================================================
--- /gsdl/trunk/lib/sqlitedbclass.cpp	(revision 15641)
+++ /gsdl/trunk/lib/sqlitedbclass.cpp	(revision 15642)
@@ -38,9 +38,9 @@
 
 // returns true if opened
-bool sqlitedbclass::opendatabase(const text_t &filename, int mode, int num_retrys, 
+bool sqlitedbclass::opendatabase (const text_t &filename, int mode, int num_retrys, 
 #ifdef __WIN32__
-			       bool need_filelock
+				  bool need_filelock
 #else
-			       bool
+				  bool
 #endif
 			      )
@@ -72,5 +72,5 @@
 
 
-void sqlitedbclass::closedatabase()
+void sqlitedbclass::closedatabase ()
 {
   if (sqlitefile == NULL) return;
@@ -82,6 +82,27 @@
 
 
+void sqlitedbclass::deletekey (const text_t &key)
+{
+  text_t sql_cmd = "DELETE FROM data WHERE key='" + key + "'";
+  sqlexec(sql_cmd);
+}
+
+
+// returns true if exists
+bool sqlitedbclass::exists (const text_t& key)
+{
+  text_t sql_cmd = "SELECT value FROM data WHERE key='" + key + "'";
+  vector<text_tmap> sql_results;
+  if (!sqlgetarray(sql_cmd, sql_results) || sql_results.size() == 0)
+  {
+    return false;
+  }
+
+  return true;
+}
+
+
 // returns true on success
-bool sqlitedbclass::getinfo(const text_t& key, infodbclass &info)
+bool sqlitedbclass::getinfo (const text_t& key, infodbclass &info)
 {
   text_t sql_cmd = "SELECT value FROM data WHERE key='" + key + "'";
@@ -106,20 +127,32 @@
 
 
-// returns true if exists
-bool sqlitedbclass::exists(const text_t& key)
-{
-  text_t sql_cmd = "SELECT value FROM data WHERE key='" + key + "'";
+// returns array of keys
+text_tarray sqlitedbclass::getkeys ()
+{
+  text_tarray keys;
+
+  // Get all the entries in the "key" column of the table
+  text_t sql_cmd = "SELECT key FROM data";
   vector<text_tmap> sql_results;
   if (!sqlgetarray(sql_cmd, sql_results) || sql_results.size() == 0)
   {
-    return false;
-  }
-
-  return true;
+    return keys;
+  }
+
+  // Iterate through the keys and add them to the array to be returned
+  vector<text_tmap>::iterator sql_results_iterator = sql_results.begin();
+  while (sql_results_iterator != sql_results.end())
+  {
+    text_tmap sql_result = (*sql_results_iterator);
+    keys.push_back(sql_result["key"]);
+    sql_results_iterator++;
+  }
+
+  return keys;
 }
 
 
 // returns true on success
-bool sqlitedbclass::setinfo(const text_t &key, const infodbclass &info)
+bool sqlitedbclass::setinfo (const text_t &key, const infodbclass &info)
 {
   text_t subkey;
@@ -196,39 +229,7 @@
 
 
-void sqlitedbclass::deletekey (const text_t &key)
-{
-  text_t sql_cmd = "DELETE FROM data WHERE key='" + key + "'";
-  sqlexec(sql_cmd);
-}
-
-
-text_tarray sqlitedbclass::getkeys ()
-{
-  text_tarray keys;
-
-  // Get all the entries in the "key" column of the table
-  text_t sql_cmd = "SELECT key FROM data";
-  vector<text_tmap> sql_results;
-  if (!sqlgetarray(sql_cmd, sql_results) || sql_results.size() == 0)
-  {
-    return keys;
-  }
-
-  // Iterate through the keys and add them to the array to be returned
-  vector<text_tmap>::iterator sql_results_iterator = sql_results.begin();
-  while (sql_results_iterator != sql_results.end())
-  {
-    text_tmap sql_result = (*sql_results_iterator);
-    keys.push_back(sql_result["key"]);
-    sql_results_iterator++;
-  }
-
-  return keys;
-}
-
-
 // returns true on success
 bool sqlitedbclass::getinfoline (text_t::iterator &here, text_t::iterator end, 
-			       text_t &key, text_t &value)
+				 text_t &key, text_t &value)
 {
   key.clear();
Index: /gsdl/trunk/lib/sqlitedbclass.h
===================================================================
--- /gsdl/trunk/lib/sqlitedbclass.h	(revision 15641)
+++ /gsdl/trunk/lib/sqlitedbclass.h	(revision 15642)
@@ -41,8 +41,8 @@
   bool opendatabase (const text_t &filename, int mode, int num_retrys, 
 		     bool need_filelock);
+
   void closedatabase ();
 
-  // returns true on success
-  bool getinfo (const text_t& key, infodbclass &info);
+  void deletekey (const text_t &key);
 
   // returns true if exists
@@ -50,9 +50,11 @@
 
   // returns true on success
+  bool getinfo (const text_t& key, infodbclass &info);
+
+  // returns array of keys
+  text_tarray getkeys ();
+
+  // returns true on success
   bool setinfo (const text_t &key, const infodbclass &info);
-
-  void deletekey (const text_t &key);
-
-  text_tarray getkeys ();
 
 protected: